//1.ADD URL http://arduino.esp8266.com/stable/package_esp8266com_index.json  IN PREFRENCES CLICK IN FILE 
//2.CHANGE WIFI NAME & PASSWORD
//3.CHANGE ADAFRUIT USER NAME & AUTH KEY AS PER ADAFRUIT ACCOUNT
//4.BRUN THIS PROGRAM YOUR NODE ESP 32 IN TOOLS: SELECT BOARD NODE MCU 1.0 12E , UPLOAD SPEED 115200,CPU FREQ 80MHz,Flash Size 4MB,DIBUG PORT DISABLE,VTABLE FLASH
#include <ESP8266WiFi.h>
#include <Adafruit_Sensor.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"
#define S0 D0
#define WLAN_SSID       "Samsungi"             // *************************Your WIFI NAME SSID********************** CHANGE IT(1)
#define WLAN_PASS       "abcd123456"        // ****************************Your WIFI password*********************** CHANGE IT(2)
#define AIO_SERVER      "io.adafruit.com" //Adafruit Server
#define AIO_SERVERPORT  1883                   
#define AIO_USERNAME    "jitendra41085"            //********************* Adafruit Username************************ CHANGE IT (3)
#define AIO_KEY         "859813f4cb144ee5b0f9e124a239a3f4"   // ************adafruit Auth Key*********************** CHANGE IT (4)
WiFiClient client;
Adafruit_MQTT_Client mqtt(&client, AIO_SERVER, AIO_SERVERPORT, AIO_USERNAME, AIO_KEY);
Adafruit_MQTT_Publish photocel3 = Adafruit_MQTT_Publish(&mqtt, AIO_USERNAME "/feeds/Relay1");
void MQTT_connect();
void setup(void)
{ 
   pinMode(S0,INPUT);
  Serial.begin(9600);
  delay(10);
  // Connect to WiFi access point.
  Serial.println(); Serial.println();
  Serial.print("Connecting to ");
  Serial.println(WLAN_SSID);

  WiFi.begin(WLAN_SSID, WLAN_PASS);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println();

  Serial.println("WiFi connected");
  Serial.println("IP address: "); 
  Serial.println(WiFi.localIP());
 }

void loop() {
  
  MQTT_connect();
 if (! photocel3.publish(digitalRead(D0))) {
    Serial.println(F("Failed"));
  } else {
    Serial.println(F("OK!"));
  }
  delay(10);
}
void MQTT_connect() {
  int8_t ret;

  if (mqtt.connected()) {
    delay(5000);//1
    return;
  }

  Serial.print("Connecting to MQTT... ");
  uint8_t retries = 3;
  while ((ret = mqtt.connect()) != 0) {
    Serial.println(mqtt.connectErrorString(ret));
    Serial.println("Retrying MQTT connection in 5 seconds...");
    mqtt.disconnect();
    delay(11000); 
    retries--;
    if (retries == 0) {
      while (1);
    }
  }
  Serial.println("MQTT Connected!");
}
